#!/bin/perl

#!/usr/bin/perl

# this is a script version of LCM, finding all frequent itemsets

$ARGC = @ARGV;
if ( $ARGC < 1 ){
  printf ("lcm.pl: threshold [separator] < input-file > output-file\n");
  exit (1);
}

$sigma = $ARGV[0];
$sep = " ";
if ( $ARGC >= 2 ){ $sep = $ARGV[1]; } 

# input the database, and remove newline code
# at the same time, construct Occ(emptyset)
$Dsiz = 0;
while (<STDIN>){
  chomp;
  @transaction = split($sep, $_);
  foreach $item( @transaction ) { push ( @{$DD[0][$Dsiz]}, $item); }
  $global_Occ[$Dsiz] = $Dsiz;
  $Dw[0][$Dsiz] = 1;
  $Dsiz++;
}

@itemset = (); @add = (); %Occs; %frq; $lev = 1; $cur_frq = $Dsiz;
iter ( \@global_Occ, "" );




sub iter{
  my ($Occ, $item ) = @_;
    # memory the size of add. At the end of iteration, the items added to
    # add will be removed from add.
  $addt[$lev] = $#add;
  
#  print "itemset: item= $item, itemset=$#itemset: @itemset   Occ= @$Occ \n";
  
    # in recursive call of not a start level, compute the frequency of
    # each item and construct a conditional database by using Occ
    # (occurrence of the current itemset).
  frq_count ( \@$Occ, $item );

    # remove infrequent items and completely included items from jump
  rm_infrq ();

  $ilev=0; output_itemsets ();
  
    # make a conditional database
  condi_dat( \@$Occ, $item );

  if ( $#itemset >= 0 ){
      # sort the items by their frequencies
    @{$jump[$lev]} = sort{$item_order{$a} <=> $item_order{$b}} @{$jump[$lev]};
  } else {
      # determine the item ordering by decreasing order of frequency and
      # sort the items in each transaction in the order
    sort_dat();
  }
  
#  if ( $#{$jump[$lev]} > 1 && $#{$DD[$lev]}>10 ){ shrink_dat (); }
  occ_deliv ( \@{$DD[$lev]}, \%Occs );
  
#  $flag[$lev] = 0;
  foreach $i( @{$jump[$lev]} ) {
    push ( @itemset, $i );
    $cur_frq = $frq{$i};
#    if ( $flag[$lev] == 0 ){  $ilev=0; output_itemsets (); $flag[$lev] = 1; }
#    else {
      $lev++;
      iter ( \@{$Occs{$i}}, $i );
      $lev--;
#    }
    $i = pop ( @itemset );
    delete ( $Occs{$i} );
    delete ( $frq{$i} );
  }

    # clear the memory used in this iteration.
  undef ( @{$jump[$lev]} );
  undef ( @{$DD[$lev]} );
  undef ( @{$Dw[$lev]} );
    # remove the items added to "add" in this iteration
  while ( $addt[$lev] < $#add ){ pop ( @add ); }
}



# sort items of each transaction according to their frequencies 
sub sort_dat{
    # sort all items
  @{$jump[1]} = sort{$frq{$b} <=> $frq{$a}} @{$jump[1]};
  
    # make item ordering array
  $i=0; foreach (@{$jump[1]} ){
    $item_order{$_} = $i;
    $i++;
  }
  
    # sort each transaction by item ordering array
  $i=0;
  foreach ( @{$DD[1]} ) {
    @{$DD[1][$i]} = sort{$item_order{$a} <=> $item_order{$b}} @{$_};
    $i++;
  }
}

# output itemsets
sub output_itemsets{
  if ( $ilev > $#add ){
    print "@itemset ($cur_frq)\n";
  } else {
    $ilev++;
    output_itemsets ();
    push ( @itemset, $add[$ilev-1] );
    output_itemsets ();
    pop (@itemset);
    $ilev--;
  }
}

# count the frequency of each item in D by occurrence deliver, and
# collect items with non-zero frequencies in jump[lev].
sub frq_count{
  my ($Occ, $end ) = @_;
  foreach ( @$Occ ) {
    $w = $Dw[$lev-1][$_];
    foreach $item( @{$DD[$lev-1][$_]} ) {
      if ( $item eq $end ){ last; }
      if ( !exists($frq{$item}) ){ push ( @{$jump[$lev]}, $item ); }
      $frq{$item} += $w;
    }
  }
}

# compute the occurrences for all items
sub occ_deliv{
  $i = 0;
  foreach $trans( @{$DD[$lev]} ) {
    foreach $item( @$trans ) { push (@{$Occs{$item}}, $i); }
    $i++;
  }
}

# remove infrequent/completely-included items from jump
sub rm_infrq{

    # make item ordering array
  $i=0; $ii=0; foreach (@{$jump[$lev]} ){
    $ff = $jump[$lev][$i];
    if ( $frq{$ff} == $cur_frq ){
      # if $ff is included in all transactions, insert it to additional
      # item llist "add". itemset + (any subset) will be output.
     push ( @add, $ff );
    } elsif ( $frq{$ff} >= $sigma ){
      $jump[$lev][$ii] = $ff;
      $ii++; $i++;
      next;
    }
      # delete frquency of infrequent item for the re-use
    delete ( $frq{$jump[$lev][$i]} );
    $i++;
  }
    # delete unnecessary elements of jump which are used by (infrequent) items.
  while ($ii<$i){
    delete $jump[$lev][$ii];
    $ii++;
  }
}

# construct a database composed of Occ, and only of frequent items,
# and less than the given item
sub condi_dat{
  my ($Occ, $end ) = @_, $i=0;
  foreach $tID( @$Occ ) {
    foreach $ii( @{$DD[$lev-1][$tID]} ) {
      if ( $ii eq $end ){ last; }
      if ( $frq{$ii} >= $sigma ){ push ( @{$DD[$lev][$i]}, $ii); }
    }
    if ( $#{$DD[$lev][$i]} >= 0 ){ $Dw[$lev][$i] = $Dw[$lev-1][$tID]; $i++; }
  }
}

# unify duplicated transactions into one transaction
sub shrink_dat{
  %identity = ();
  $i = 0; $ii = 0;
  foreach $trans( @{$DD[$lev]} ) {
    $sig = join ( ' ', @$trans );
    if ( exists($identity{$sig}) ){
      $Dw[$lev][$identity{$sig}] += $Dw[$lev][$i];
    } else {
      $identity{$sig} = $ii;
      @{$DD[$lev][$ii]} = @{$DD[$lev][$i]};
      $Dw[$lev][$ii] = $Dw[$lev][$i];
      $ii++;
    }
    $i++;
  }
  while ($ii<$i){
    delete $Dw[$lev][$ii];
    delete $DD[$lev][$ii];
    $ii++;
  }
  
}


sub print_D{
  my ($l, $Occ) = @_;
  if ( $#Occ >= 0 ){
    foreach $tID(@{$Occ}){
      foreach $ii(@{$DD[$l][$tID]}){ print "$_ "; }
      print ": $Dw[$l][$tID]\n";
    }
  } else {
    $i=0;
    foreach $trans(@{$DD[$l]}){
      foreach (@{$trans}){ print "$_ "; }
      print ": $Dw[$l][$i]\n";
      $i++;
    }
  } 
}


